// This file was generated by counterfeiter
package canaryfakes

import (
	"database/sql"
	"sync"

	"github.com/pivotal-cf-experimental/replication-canary/canary"
)

type FakeSQLClient struct {
	SetupStub        func(*sql.DB) error
	setupMutex       sync.RWMutex
	setupArgsForCall []struct {
		arg1 *sql.DB
	}
	setupReturns struct {
		result1 error
	}
	WriteStub        func(*sql.DB, string) error
	writeMutex       sync.RWMutex
	writeArgsForCall []struct {
		arg1 *sql.DB
		arg2 string
	}
	writeReturns struct {
		result1 error
	}
	CheckStub        func(*sql.DB, string) (bool, error)
	checkMutex       sync.RWMutex
	checkArgsForCall []struct {
		arg1 *sql.DB
		arg2 string
	}
	checkReturns struct {
		result1 bool
		result2 error
	}
	CleanupStub        func(*sql.DB) error
	cleanupMutex       sync.RWMutex
	cleanupArgsForCall []struct {
		arg1 *sql.DB
	}
	cleanupReturns struct {
		result1 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeSQLClient) Setup(arg1 *sql.DB) error {
	fake.setupMutex.Lock()
	fake.setupArgsForCall = append(fake.setupArgsForCall, struct {
		arg1 *sql.DB
	}{arg1})
	fake.recordInvocation("Setup", []interface{}{arg1})
	fake.setupMutex.Unlock()
	if fake.SetupStub != nil {
		return fake.SetupStub(arg1)
	} else {
		return fake.setupReturns.result1
	}
}

func (fake *FakeSQLClient) SetupCallCount() int {
	fake.setupMutex.RLock()
	defer fake.setupMutex.RUnlock()
	return len(fake.setupArgsForCall)
}

func (fake *FakeSQLClient) SetupArgsForCall(i int) *sql.DB {
	fake.setupMutex.RLock()
	defer fake.setupMutex.RUnlock()
	return fake.setupArgsForCall[i].arg1
}

func (fake *FakeSQLClient) SetupReturns(result1 error) {
	fake.SetupStub = nil
	fake.setupReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeSQLClient) Write(arg1 *sql.DB, arg2 string) error {
	fake.writeMutex.Lock()
	fake.writeArgsForCall = append(fake.writeArgsForCall, struct {
		arg1 *sql.DB
		arg2 string
	}{arg1, arg2})
	fake.recordInvocation("Write", []interface{}{arg1, arg2})
	fake.writeMutex.Unlock()
	if fake.WriteStub != nil {
		return fake.WriteStub(arg1, arg2)
	} else {
		return fake.writeReturns.result1
	}
}

func (fake *FakeSQLClient) WriteCallCount() int {
	fake.writeMutex.RLock()
	defer fake.writeMutex.RUnlock()
	return len(fake.writeArgsForCall)
}

func (fake *FakeSQLClient) WriteArgsForCall(i int) (*sql.DB, string) {
	fake.writeMutex.RLock()
	defer fake.writeMutex.RUnlock()
	return fake.writeArgsForCall[i].arg1, fake.writeArgsForCall[i].arg2
}

func (fake *FakeSQLClient) WriteReturns(result1 error) {
	fake.WriteStub = nil
	fake.writeReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeSQLClient) Check(arg1 *sql.DB, arg2 string) (bool, error) {
	fake.checkMutex.Lock()
	fake.checkArgsForCall = append(fake.checkArgsForCall, struct {
		arg1 *sql.DB
		arg2 string
	}{arg1, arg2})
	fake.recordInvocation("Check", []interface{}{arg1, arg2})
	fake.checkMutex.Unlock()
	if fake.CheckStub != nil {
		return fake.CheckStub(arg1, arg2)
	} else {
		return fake.checkReturns.result1, fake.checkReturns.result2
	}
}

func (fake *FakeSQLClient) CheckCallCount() int {
	fake.checkMutex.RLock()
	defer fake.checkMutex.RUnlock()
	return len(fake.checkArgsForCall)
}

func (fake *FakeSQLClient) CheckArgsForCall(i int) (*sql.DB, string) {
	fake.checkMutex.RLock()
	defer fake.checkMutex.RUnlock()
	return fake.checkArgsForCall[i].arg1, fake.checkArgsForCall[i].arg2
}

func (fake *FakeSQLClient) CheckReturns(result1 bool, result2 error) {
	fake.CheckStub = nil
	fake.checkReturns = struct {
		result1 bool
		result2 error
	}{result1, result2}
}

func (fake *FakeSQLClient) Cleanup(arg1 *sql.DB) error {
	fake.cleanupMutex.Lock()
	fake.cleanupArgsForCall = append(fake.cleanupArgsForCall, struct {
		arg1 *sql.DB
	}{arg1})
	fake.recordInvocation("Cleanup", []interface{}{arg1})
	fake.cleanupMutex.Unlock()
	if fake.CleanupStub != nil {
		return fake.CleanupStub(arg1)
	} else {
		return fake.cleanupReturns.result1
	}
}

func (fake *FakeSQLClient) CleanupCallCount() int {
	fake.cleanupMutex.RLock()
	defer fake.cleanupMutex.RUnlock()
	return len(fake.cleanupArgsForCall)
}

func (fake *FakeSQLClient) CleanupArgsForCall(i int) *sql.DB {
	fake.cleanupMutex.RLock()
	defer fake.cleanupMutex.RUnlock()
	return fake.cleanupArgsForCall[i].arg1
}

func (fake *FakeSQLClient) CleanupReturns(result1 error) {
	fake.CleanupStub = nil
	fake.cleanupReturns = struct {
		result1 error
	}{result1}
}

func (fake *FakeSQLClient) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.setupMutex.RLock()
	defer fake.setupMutex.RUnlock()
	fake.writeMutex.RLock()
	defer fake.writeMutex.RUnlock()
	fake.checkMutex.RLock()
	defer fake.checkMutex.RUnlock()
	fake.cleanupMutex.RLock()
	defer fake.cleanupMutex.RUnlock()
	return fake.invocations
}

func (fake *FakeSQLClient) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ canary.SQLClient = new(FakeSQLClient)
